import React, { Component } from "react";
import Button from "react-bootstrap/esm/Button";
import Card from 'react-bootstrap/Card';
import Table from 'react-bootstrap/Table';

class UserItem extends Component {
    render() {
        const user = this.props.user
        let editButtonID = "UserItemEditButton" + user.userID
        let deleteButtonID = "UserItemDeleteButton" + user.userID
        let itemID = "UserItem" + user.userID
        let dialogData = {
            dialogID: "DeleteDialogUser" + user.userID,
            name: user.firstName + " " + user.lastName,
            userID: user.userID
        }
        return (
            <div>
                <Card style={{ width: "18rem", background: '#ebebeb', margin: "0.5rem" }} id={itemID}>
                    <Card.Header><b>{user.firstName} {user.lastName}</b></Card.Header>
                    <Table responsive="sm">
                        <tbody>
                            <tr>
                                <td><b>User ID:</b></td>
                                <td style={{ textAlign: 'left' }}>{user.userID}</td>
                            </tr>
                            <tr>
                                <td><b>First Name:</b></td>
                                <td style={{ textAlign: 'left' }}>{user.firstName}</td>
                            </tr>
                            <tr>
                                <td><b>Last Name:</b></td>
                                <td style={{ textAlign: 'left' }}>{user.lastName}</td>
                            </tr>
                        </tbody>
                    </Table>
                    <Card.Footer style={{ display: 'flex', justifyContent: 'space-evenly' }}>
                        <Button variant="primary" onClick={(e) => this.props.handleShowEditPage(e, user)} id={editButtonID} >Edit</Button>
                        <Button variant="primary" type="submit" onClick={(e) => this.props.handleShowDeleteModal(e, dialogData)} id={deleteButtonID} style={{ background: '#ffc800', color: 'black', border: 'none' }}>
                            Delete
                        </Button>
                    </Card.Footer>
                </Card>
            </div>
        )
    }
}


export default UserItem