import * as userManagementActions from '../actions/UserManagementActions'

const initialState = {
    showDeleteUserModal: false,
    deleteModalData: null,
    userList: null,
    newUserData: null,
    editUserData: null
};

function userManagementReducer(state = initialState, action) {
    switch (action.type) {
        case userManagementActions.SHOW_DELETE_USER_MODAL:
            return {
                ...state,
                showDeleteUserModal: true,
                deleteModalData: action.deleteModalData,
                error: null
            }
        case userManagementActions.HIDE_DELETE_USER_MODAL:
            return {
                ...state,
                showDeleteUserModal: false,
                deleteModalData: null,
                error: null
            }

        case userManagementActions.DELETE_USER_SUCCESS:
            return {
                ...state,
                showDeleteUserModal: false,
                error: null
            }

        case userManagementActions.DELETE_USER_ERROR:
            return {
                ...state,
                showDeleteUserModal: false,
                error: "deleting user failed"
            }


        case userManagementActions.EDIT_USER_SUCCESS:
            return {
                ...state,
                editUserData: action.editUserData,
                error: null
            }

        case userManagementActions.EDIT_USER_ERROR:
            return {
                ...state,
                error: "editing user failed"
            }


        case userManagementActions.SHOW_ALL_USERS:
            return {
                ...state,
                userList: action.userList,
                error: null
            }

        case userManagementActions.ALL_USERS_ERROR:
            return {
                ...state,
                error: "displaying all users failed"
            }


        case userManagementActions.CREATE_NEW_USER_SUCCESS:
            return {
                ...state,
                newUserData: action.userData,
                error: null
            }


       
        default:
            return state;
    }
};

export default userManagementReducer;